<?php
// Message  返回json格式，(错误码,错误提示[success / error],错误信息,显示数据)
class api extends mysqlquery{
    public $empire;

    public function __construct(){
       $this->empire = new mysqlquery();
    }

    //获取网站关键字，描述等信息
    public function getWebInfo(){
       global $dbtbpre,$public_r;
       $data = [];
       $info = $this->empire->fetch1("select sitekey,siteintro from {$dbtbpre}enewspublic order by id desc");
       $data['sitename'] = $public_r['sitename'];
       $data['sitekey']    =   $info['sitekey'];
       $data['siteintro']  =   $info['siteintro'];
       return $data;
    }

    // 面包屑 - layui样式
    public function breadcrumb($breadcrumbArr,$join = ''){
        $arr = "";
        if($breadcrumbArr && is_array($breadcrumbArr)){
            $i = 0;
            $num = count($breadcrumbArr);
            foreach ($breadcrumbArr as $breadcrumb) {
                $i++;
                $style = "";
                $i==$num?$style=" class='active'":"";
                if($breadcrumb['href']){
                    $arr .= '<a href="'.$breadcrumb['href'].'">'.$breadcrumb['text'].'</a>';
                }else{
                    $arr .= '<a><cite>'.$breadcrumb['text'].'</cite></a>';
                }
            }
        }else{
            $arr .= '<a href="#">Home</a><a href="#">插件</a><a><cite>配置信息</cite></a>';
        }
        if($join){
            $breadcrumb = '<span class="layui-breadcrumb" lay-separator="'.$join.'" style="visibility: visible;">'.$arr.'</span>';
        }else{
            $breadcrumb = '<span class="layui-breadcrumb" style="visibility: visible;">'.$arr.'</span>';
        }

        return $breadcrumb;
    }

    // 面包屑 - bootstrap样式
    public function breadcrumb2($breadcrumbArr){
        $arr = "";
        if($breadcrumbArr && is_array($breadcrumbArr)){
            $i = 0;
            $num = count($breadcrumbArr);
            foreach ($breadcrumbArr as $breadcrumb) {
                $i++;
                $style = "";
                $i==$num?$style=" class='active'":"";
                $arr .= '<li'.$style.'>';
                if($breadcrumb['href']){
                    $arr .= '<a href="'.$breadcrumb['href'].'">'.$breadcrumb['text'].'</a>';
                }else{
                    $arr .= $breadcrumb['text'];
                }
                $arr .= '</li>';
            }
        }else{
            $arr .= '<li><a href="#">Home</a></li><li><a href="#">插件</a></li><li class="active">配置信息</li>';
        }
        $breadcrumb = '<ol class="breadcrumb">'.$arr.'</ol>';
        return $breadcrumb;
    }
    
    /** 上传文件
     * @param  String  $idname      上传的文本框的name名称
     * @param  String  $newFileUrl  指定的上传路径
     * @return JSON
     */
    public function uploadFile($post){
        //转换参数形式
        foreach ($post as $kp=>$p) {
            $$kp = $p;
        };

        if (!file_exists($_FILES[$idname]['tmp_name']))
        //是否存在文件
        {
            return $this->Message(400,'error','图片不存在');
        }

        if($_FILES[$idname]['tmp_name']){
            $picUrl = json_decode($this->uploadPic($_FILES[$idname],$newFileUrl),true);

            if($picUrl['ret'] == 400){
                return $this->Message(400,'error',$picUrl['info']);
            }else{
                return $this->Message(200,'success','',$picUrl['data']['url']);
            };
        }else{
            return $this->Message(400,'调试','图片不存在');
        };
    }

    // 通过layui的上传组件 直接上传图片
    public function uploadFile2($post){
        $newFileUrl = "/e/extend/test/theme/pic/";
        foreach ($_FILES as $key => $val){
            if (!file_exists($val['tmp_name']))
            //是否存在文件
            {
                return $this->Message(400,'error','图片不存在');
            }
            if($val['tmp_name']){
                $picUrl = json_decode($this->uploadPic($val,$newFileUrl),true);

                if($picUrl['ret'] == 400){
                    return $this->Message(400,'error',$picUrl['info']);
                }else{
                    return $this->Message(200,'success','',$picUrl['data']['url']);
                };
            }else{
                return $this->Message(400,'调试','图片不存在');
            };
        }
    }

    //获取news表列表
    public function getList($post){
        global $empire,$public_r,$class_r,$dbtbpre;
        //转换参数形式
        foreach ($post as $kp=>$p) {
            $$kp = $p;
        };
        if(!$classid){
            return $this->Message(400,'error','classid获取失败');
        };
        $rows = [];
        //页数预处理
        (isset($pageNo) && is_numeric($pageNo)) ? $pageNo = $pageNo : $pageNo = 1;
        //每页条数预处理
        (isset($pageSize) && is_numeric($pageSize)) ? $pageSize = $pageSize : $pageSize = 20;

        $sonClassIds = trim(str_replace("|",",",$class_r[$classid]['sonclass']),',');

        $where = ' where classid in ('.$sonClassIds.')';

        $count = $this->empire->gettotal("select count(*) as total from {$dbtbpre}ecms_news".$where);

        //获取最大页数
        $pages = ceil($count/$pageSize);
        //如果传递的页码大于总页数，则取最大页数
        if ($pageNo > $pages && $pages!=0) {
            $pageNo = $pages;
        }
        //开始的记录位置
        $start = ($pageNo - 1) * $pageSize;
        //记录范围
        $limit = $pageSize;

        if($count){
            //根据筛选条件获取记录
            $sql=$this->empire->query("select * from {$dbtbpre}ecms_news".$where." order by id desc limit $start, $limit");
            while($r=$this->empire->fetch($sql)){
                $cls = $class_r[$classid];
                $titleurl = $public_r['newsurl'].$cls['classpath'].'/'.$r['id'].$cls['classtype'];
                $smalltext = esub($r['smalltext'],100,'...');
                $titlepic = sys_ResizeImg($r['titlepic'],165,180,2);
                $rows[]=[
                    'title'     =>  $r['title'],
                    'titleurl'  =>  $titleurl,
                    'smalltext' =>  $smalltext,
                    'titlepic'  =>  $titlepic
                ];
            }
        }
        //返回数组对象
        $res = array(
            'count'   => $count,
            'pageNo'  => $pageNo,
            'pages'   => $pages,
            'rows'    => $rows
        );
        return $this->Message(200,'success','',$res);
    }

    //自定义分页函数
    function yoyo_page1($num,$line,$page_line,$start,$page,$search){
        global $empire,$class_r,$dbtbpre,$public_r,$fun_r;
        if($num<=$line)
        {
            return '';
        }
        $search=RepPostStr($search,1);
        $url=eReturnSelfPage(0).'?page';
        $snum=2;//最小页数
        $totalpage=ceil($num/$line);//取得总页数
        $firststr = '<nav><ul class="pagination">';

        //上一页
        if($page<>0)
        {
            //这个是跳到首页
            $toppage='<li><a href="'.$url.'=0'.$search.'">首页</a></li>';

            $pagepr=$page-1;
            $prepage='<li><a href="'.$url.'='.$pagepr.$search.'" aria-label="Previous"><span aria-hidden="true">«</span></a></li>';   //这个是上一页
        }

        //下一页
        if($page!=$totalpage-1)
        {
            //下一页
            $pagenex = $page+1;
            $nextpage = '<li class="2"><a href="'.$url.'='.$pagenex.$search.'" aria-label="Next"><span aria-hidden="true">»</span></a></li>';

            //跳到尾页
            $lastpage = '<li><a href="'.$url.'='.($totalpage-1).$search.'">尾页</a></li>';
        }

        $firststr .= '<li><a title="'.$fun_r['trecord'].'">共 '.$num.' 条</a></li>';

        $starti=$page-$snum<0?0:$page-$snum;
        $no=0;
        for($i=$starti;$i<$totalpage&&$no<$page_line;$i++)
        {
            $no++;
            if($page==$i)
            {
                $is_1="<li class='active'><a href='javascript:void(0);'>";
                $is_2="</a></li>";
            }
            else
            {
                $is_1='<li><a href="'.$url.'='.$i.$search.'">';
                $is_2="</a></li>";
            }
            $pagenum=$i+1;
            $returnstr.=$is_1.$pagenum.$is_2;
        }
        //toppage上一页 prepage下一页
        $returnstr=$firststr.$toppage.$prepage.$returnstr.$nextpage.$lastpage;
        // $returnstr=$firststr.$toppage.$returnstr.$lastpage;
        $returnstr .= '</ul></nav>';
        return $returnstr;
    }
    
    /**上传文件
    * @param $_FILES     指定上传文件的变量
    * @param $uploadPath 指定的上传目录
    * 
    * @return JSON
    * @return 文件格式        -> [filetype] => .jpg
    * @return 写入的文件名    -> [insertfileName] => 623b9f6b946f570bd24a5765c2fbf442
    * @return 写入的文件名    -> [filename] => 623b9f6b946f570bd24a5765c2fbf442.jpg
    * @return 文件路径        -> [filepath] => e/extend/tagMan/tagPic/
    * @return 保存的物理路径  -> [savePath] => /www/web/demo16/public_html/e/extend/tagMan/tagPic/
    * @return 返回的文件路径  -> [url] => /e/extend/tagMan/tagPic/623b9f6b946f570bd24a5765c2fbf442.jpg
    * @return 缩略图路径      -> [thumbnailName] => /www/web/demo16/public_html/e/extend/tagMan/tagPic/small623b9f6b946f570bd24a5765c2fbf442
    * @return 文件大小        -> [filesize] => 42257
    * 
    */
    private function uploadPic($file,$uploadPath = ""){
        global $empire,$public_r,$loginrnd,$dbtbpre,$ecms_config;

        if(empty($file['name']) || empty($file['type']) || empty($file['tmp_name'])){
            return $this->Message(400,'error','上传有误，请重试!');
        };

        $filetype = GetFiletype($file['name']);//取得文件类型
        $type_r = explode("|".$filetype."|",$public_r['filetype']); //检查是否配置信息中允许的文件后缀，不限于图片格式
        if(count($type_r)<2)
        {
            return $this->Message(400,'error','您上传的类型有误，系统不接受!');
        }
        if($file['size']>$public_r['filesize']*1024)
        {
            return $this->Message(400,'error','系统限制的最大文件大小为 '.$public_r['filesize'].' KB');
        }
        //配置信息中的图片后缀与当前上传的图片后缀进行匹配
        if(!strstr($ecms_config['sets']['tranpicturetype'],','.$filetype.','))
        {
            return $this->Message(400,'error','您上传的不是图片文件,请重新选择！');
        }
        $params = [
            'filetype'  =>  $filetype,        //文件类型
            'filename'  =>  $file['name'],    //原文件名
            'filesize'  =>  $file['size'],    //文件大小
            'tmpname'   =>  $file['tmp_name'],
            'uploadPath'=>  $uploadPath
        ];

        $upload = $this->DoTranFile($params);

        if($upload['ret'] == 400){
            return $this->Message(400,'error',$upload['info']);
        }else{
            return $this->Message(200,'success','',$upload);
        }
        
    }
    //取得文件扩展名
    function GetFiletype($filename){
        $filer=explode(".",$filename);
        $count=count($filer)-1;
        return strtolower(".".RepGetFiletype($filer[$count]));
    }

    function RepGetFiletype($filetype){
        $filetype=str_replace('|','_',$filetype);
        $filetype=str_replace(',','_',$filetype);
        $filetype=str_replace('.','_',$filetype);
        return $filetype;
    }

    /** 上传文件 
    * @param  filetype   文件类型 
    * @param  filename   原文件名
    * @param  filesize   文件大小
    * @param  tmpname    临时文件名
    * @return JSON 
    */ 
    private function DoTranFile($post){
        global $public_r,$class_r,$doetran,$efileftp_fr;
        $r = [];
        //文件类型
        $r['filetype'] = $post['filetype'];
        //文件名
        $r['insertfileName'] = $this->ReturnDoTranFilename();    //md5加密时间戳，生成待写入的文件名，不带后缀名
        $r['filename']=$r['insertfileName'].$r['filetype'];      //待写入的文件名，加后缀名
        //存放目录
        $r['filepath'] = $post['uploadPath'];
        $r['savePath'] = ECMS_PATH.ltrim($r['filepath'],'/');
        //如果存放目录不存在，则新建一个目录
        if(!file_exists($r['savePath']))
        {
            if (!mkdir($r['savePath'], 0777, true)) {
                return $this->Message(400,'error','创建路径失败，请手动建建立路径：'.$r['savePath']);
            }
        }
        //附件地址
        $r['url']=$public_r['newsurl'].ltrim($r['filepath'],'/').$r['filename'];   //返回的url地址
        //缩图文件
        $r['thumbnailName']=$r['savePath']."small".$r['insertfileName'];

        if (file_exists($r['savePath'].$r['filename']))
        {
            return $this->Message(400,'error','同名文件已经存在了！');
        }

        //上传文件
        $cp = @move_uploaded_file($post['tmpname'],$r['savePath'].$r['filename']);
        if(empty($cp))
        {   
           return $this->Message(400,'error','请查看目录权限是否为0777,文件上传不成功!'); 
        }

        //设置上传 权限
        $this->DoChmodFile($r['url']);

        $r['filesize'] = (int)$post['filesize'];

        return $r;
    }

    //返回上传文件名
    private function ReturnDoTranFilename(){
        $filename = md5(uniqid(microtime()));
        return $filename;
    }

    //设置上传权限
    private function DoChmodFile($file){
        global $public_r;
        if($public_r['filechmod']!=1)
        {
            @chmod($file,0777);
        }
    }

    //使用原生SQL返回结果 --yoyo
    function useQueryBySql($sql){
        $result = mysql_query($sql);
        $rows = array();
        if($result){
            while($row = mysql_fetch_assoc($result)){
                array_push($rows,$row);
            }
            return $rows;
        }else{
            return false;
        }
    }

    //使用原生SQL 得到结果集的数量 --yoyo
    function getResultNumBySql($sql){
        $result = mysql_query($sql);
        return mysql_num_rows($result);
    }

    //对应insert方法
    public function add($table, $data, $compatible = false)
    {
        if (empty($data) || !$this->dataEnough($data))
        {
            return false;
        }
        $data = $this->_valid($data);
        if (!$data)
        {
            $this->_error('no_valid_data');
            return false;
        }
        $insert_info = $this->_getInsertInfo($data);
        $mode = $compatible ? 'REPLACE' : 'INSERT';
        $sql = $mode." INTO `{$table}`{$insert_info['fields']} VALUES{$insert_info['values']}" ;
        $flag = $this->empire->query($sql);
        $insert_id = $this->empire->lastid();
        if ($insert_id)
        {
            if ($insert_info['length'] > 1)
            {
                for ($i = $insert_id; $i < $insert_id + $insert_info['length']; $i++)
                {
                    $id[] = $i;
                }
            }
            else
            {
                /* 添加单条记录 */
                $id = $insert_id;
            }
        }
        if ($flag && $id) {
            return $id;
        } else {
            return $flag;
        }
    }
    
    function getRow($table,$whereData = array(),$getWhat = null,$orderBy = null) {
        if (empty($getWhat)) {
            $getWhat = "*";
        }
        $s = '';
        if($whereData){
            foreach ($whereData as $k=>$v){
                if (is_string($v)) {
                    $v = addslashes($v);
                }
                if (empty($s)) {
                    $s = "`$k`='$v'";
                } else {
                    $s .= " AND `$k`='$v'";
                }
            }
            $s = " WHERE $s";
        }

        $sql = "SELECT $getWhat FROM `$table`".$s;

        if (!empty($orderBy)) {
            $sql .= " ORDER BY $orderBy ";
        }

        $sql .= " LIMIT 1";
        $res = $this->empire->fetch1($sql);
        return $res;
    }

    function getRows($table,$whereData,$getWhat = null, $orderBy = null, $start = 0, $limit = 0) {
        if (empty($getWhat)) {
            $getWhat = "*";
        }
        $s = '';
        foreach ($whereData as $k=>$v){
            if (is_string($v)) {
                $v = addslashes($v);
            }
            if (empty($s)) {
                $s = "`$k`='$v'";
            } else {
                $s .= " AND `$k`='$v'";
            }
        }
        
        $sql = "SELECT $getWhat FROM `$table`";
    
        if (!empty($s)) {
            $sql .= " WHERE $s ";   
        }
        
        if (!empty($orderBy)) {
            $sql .= " ORDER BY $orderBy ";
        }
        
        if ($limit > 0) {
            $sql .= " LIMIT $start,$limit";
        }

        $res = [];
        $sql = $this->empire->query($sql);
        while($r = $this->empire->fetch($sql)){
            $res[] = $r;
        }
        return $res;
    }

    function delRow($table,$data) {
        $s = '';
        foreach ($data as $k=>$v){
            if (is_string($v)) {
                $v = addslashes($v);
            }
            if (empty($s)) {
                $s = "`$k`='$v'";
            } else {
                $s .= " AND `$k`='$v'";
            }
        }
        $sql = "DELETE FROM `$table` WHERE $s LIMIT 1";
    
        $flag = $this->empire->query($sql);
    
        return $flag;
    }
    
    function delRows($data) {
        $s = '';
        foreach ($data as $k=>$v){
            if (is_string($v)) {
                $v = addslashes($v);
            }
            if (empty($s)) {
                $s = "`$k`='$v'";
            } else {
                $s .= " AND `$k`='$v'";
            }
        }
        $sql = "DELETE FROM `$table` WHERE $s";
        $flag = $this->empire->query($sql);
    
        return $flag;
    }

    function updateRow($table, $data,$condition) {
        $s = '';
        foreach ($data as $k=>$v){
            if (is_string($v)) {
                $v = addslashes($v);
            }
            if (empty($s)) {
                $s = "`$k`='$v'";
            } else {
                $s .= ",`$k`='$v'";
            }
        }
        $sql = "UPDATE `$table` SET $s WHERE $condition LIMIT 1";
        
        $flag = $this->empire->query($sql);
        
        return $flag;
    }

    /**
     *  获取插入的数据SQL
     *
     *  @author Garbin
     *  @param  array $data
     *  @return string
     */
    private function _getInsertInfo($data)
    {
        reset($data);
        $fields = array();
        $values = array();
        $length = 1;
        if (key($data) === 0 && is_array($data[0]))
        {
            $length = count($data);
            foreach ($data as $_k => $_v)
            {
                foreach ($_v as $_f => $_fv)
                {
                    $is_array = is_array($_fv);
                    ($_k == 0 && !$is_array) && $fields[] = $_f;
                    if (is_string($_fv)) {
                        $_fv = addslashes($_fv);
                    }
                    !$is_array && $values[$_k][] = "'{$_fv}'";
                }
                $values[$_k] = '(' . implode(',', $values[$_k]) . ')';
            }
        }
        else
        {
            foreach ($data as $_k => $_v)
            {
                $is_array = is_array($_v);
                !$is_array && $fields[] = '`'.$_k.'`';
                !$is_array && is_string($_v) && $_v = addslashes($_v);
                    
                !$is_array && $values[] = "'{$_v}'";
            }
            $values = '(' . implode(',', $values) . ')';
        }
        $fields = '(' . implode(',', $fields) . ')';
        is_array($values) && $values = implode(',', $values);
        return compact('fields', 'values', 'length');
    }
    /**
     *  验证数据合法性，当只验证vrule中指定的字段，并且只当$data中设置了其值时才验证
     *
     *  @author Garbin
     *  @param  array $data
     *  @return mixed
     */
    function _valid($data)
    {
        if (empty($this->_autov) || empty($data) || !is_array($data))
        {
            return $data;
        }
        $max = $filter = $reg = $default = $valid = '';
        reset($data);
        $is_multi = (key($data) === 0 && is_array($data[0]));
        if (!$is_multi)
        {
            $data = array($data);
        }
        foreach ($this->_autov as $_k => $_v)
        {
            if (is_array($_v))
            {
                $required = (isset($_v['required']) && $_v['required']) ? true : false;
                $type  = isset($this->_autov[$_k]['type']) ? $this->_autov[$_k]['type'] : 'string';
                $min  = isset($this->_autov[$_k]['min']) ? $this->_autov[$_k]['min'] : 0;
                $max  = isset($this->_autov[$_k]['max']) ? $this->_autov[$_k]['max'] : 0;
                $filter = isset($this->_autov[$_k]['filter']) ? $this->_autov[$_k]['filter'] : '';
                $valid= isset($this->_autov[$_k]['valid']) ? $this->_autov[$_k]['valid'] : '';
                $reg  = isset($this->_autov[$_k]['reg']) ? $this->_autov[$_k]['reg'] : '';
                $default = isset($this->_autov[$_k]['default']) ? $this->_autov[$_k]['default'] : '';
            }
            else
            {
                preg_match_all('/([a-z]+)(\((\d+),(\d+)\))?/', $_v, $result);
                $type = $result[1];
                $min  = $result[3];
                $max  = $result[4];
            }
            foreach ($data as $_sk => $_sd)
            {
                $has_set = isset($data[$_sk][$_k]);
                if (!$has_set)
                {
                    continue;
                }
                if ($required && $data[$_sk][$_k] == '')
                {
                    $this->_error("required_field", $_k);
                    return false;
                }
                /* 运行到此，说明该字段不是必填项可以为空 */
                $value = $data[$_sk][$_k];
                /* 默认值 */
                if (!$value && $default)
                {
                    $data[$_sk][$_k] = function_exists($default) ? $default() : $default;
                    continue;
                }
                /* 若还是空值，则没必要往下验证长度，正则，自定义和过滤，因为其已经是一个空值了 */
                if (!$value)
                {
                    continue;
                }
                /* 大小|长度限制 */
                if ($type == 'string')
                {
                    $strlen = strlen($value);
                    if ($min != 0 && $strlen < $min)
                    {
                        $this->_error('autov_length_lt_min', $_k);
                        return false;
                    }
                    if ($max != 0 && $strlen > $max)
                    {
                        $this->_error('autov_length_gt_max', $_k);
                        return false;
                    }
                }
                else
                {
                    if ($min != 0 && $value < $min)
                    {
                        $this->_error('autov_value_lt_min', $_k);
                        return false;
                    }
                    if ($max != 0 && $value > $max)
                    {
                        $this->_error('autov_value_gt_max', $_k);
                        return false;
                    }
                }
                /* 正则 */
                if ($reg)
                {
                    if (!preg_match($reg, $value))
                    {
                        $this->_error('check_match_error', $_k);
                        return false;
                    }
                }
                /* 自定义验证 */
                if ($valid && function_exists($valid))
                {
                    $result = $valid($value);
                    if ($result !== true)
                    {
                        $this->_error($result);
                        return false;
                    }
                }
                /* 过滤 */
                if ($filter)
                {
                    $funs    = explode(',', $filter);
                    foreach ($funs as $fun)
                    {
                        function_exists($fun) && $value = $fun($value);
                    }
                    $data[$_sk][$_k] = $value;
                }
            }
        }
        if (!$is_multi)
        {
            $data = $data[0];
        }
        return $data;
    }
    
    /**
     *    检查数据是否足够
     *
     *    @author    Garbin
     *    @param     array $data
     *    @return    bool[true:足够,false:不足]
     */
    function dataEnough($data)
    {
        $required_fields = $this->getRequiredFields();
        if (empty($required_fields))
        {
            return true;
        }
        $is_multi = (key($data) === 0 && is_array($data[0]));
        foreach ($required_fields as $field)
        {
            if ($is_multi)
            {
                foreach ($data as $key => $value)
                {
                    if (!isset($value[$field]))
                    {
                        $this->_error('data_not_enough', $field);
    
                        return false;
                    }
                }
            }
            else
            {
                if (!isset($data[$field]))
                {
                    $this->_error('data_not_enough', $field);
    
                    return false;
                }
            }
        }
    
        return true;
    }
    
    /**
     *    获取必须的字段列表
     *
     *    @author    Garbin
     *    @return    array
     */
    function getRequiredFields()
    {
        $fields = array();
        if (is_array($this->_autov))
        {
            foreach ($this->_autov as $key => $value)
            {
                if (isset($value['required']) && $value['required'])
                {
                    $fields[] = $key;
                }
            }
        }
    
        return $fields;
    }



    function Message($ret=200,$err='',$info='',$data=''){
        if(!is_numeric($ret))
        {
            return '';
        }
        $result = array(
            "ret" => $ret,
            "msg"=>$err,
            "info"=> $info,
            "data" => $data,
        );
        return $this->toJson($result);
    }


    /**
    *@todo      return json
    */
    function toJson($data)
    {
        return json_encode($data,JSON_UNESCAPED_UNICODE);
    }


    /**
    * 替换字符串中所有的回车、空格、和空值
    * @param type string
    * @return type
    */
    function trimall($str)
    {
        $needToReplaced=array(" ","　","\t","\n","\r");  //需要替换的字符
        $afterReplace=array("","","","","");
        $str = str_replace($needToReplaced,$afterReplace,$str);
        $str = stripslashes($str);
        return $str;
    }


}