<?php
require("topSdk.php");

// 获取接口中的配置信息，返回数组，如果是json 请先json_decode
//$smsConfig = $baseApi->getSmsConfig();
$smsConfig = [];

// 面包屑
$breadcrumbsArr = [
    0 => [
        'href' => $public_r['newsurl'],
        'text' => 'Home'
    ],
    1 => [
        'href' => $public_r['newsurl'].'e/extend/alidayu/config.php'.$ecms_hashur['whehref'],
        'text' => '阿里大鱼短信接入插件'
    ],
    2 => [
        'text' => '配置信息'
    ],
];

?>
<!doctype html>
<html lang="zh-cn">
<head>
    <meta charset="utf-8">
    <title><?=$public_r[sitename]?></title>
    <meta name="keywords" content="<?=$info['sitekey']?>" />
    <meta name="description" content="<?=$info['sitekey']?>" />
    <link rel="stylesheet" href="../requireCommon/layui/css/layui.css">
    <script src="../requireCommon/js/jquery.min.js"></script>
    <script src="theme/js/ajaxfileupload.js"></script><!--ajax上传另一种方式，可以不用加载-->
</head>

<body>
<div class="layui-main">
    <br>
    <?=$baseApi->breadcrumb($breadcrumbsArr)?>

    <form class="layui-form mt20" id="form1">
        <input type="hidden" name="id" value="<?=$wchatConfig['id']?>">

        <div class="layui-form-item">
            <label class="layui-form-label">是否开启</label>
            <div class="layui-input-block">
                <input type="checkbox" name="switch" lay-skin="switch" checked>
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">app_key</label>
            <div class="layui-input-block">
                <input type="text" class="layui-input" id="app_key" name="app_key" value="<?=$smsConfig['app_key']?>" lay-verify="required">
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">app_secret</label>
            <div class="layui-input-block">
                <input type="text" class="layui-input" id="app_secret" name="app_secret" value="<?=$smsConfig['app_secret']?>" lay-verify="required">
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">上传文件</label>
            <div class="layui-input-block">
                <!--上传表单，注意事项：ID与name一致，若不一致，在JS中更改-->
                <input type="file" id="exampleInputFile" name="exampleInputFile" lay-title="请上传一张图片吧亲" class="layui-upload-file">
                <input type="text" name="ceshi_file" id="ceshi_file" class="form-control">
            </div>
        </div>


        <div class="layui-form-item layui-form-text">
            <label class="layui-form-label">备注说明</label>
            <div class="layui-input-block">
                <textarea name="desc" placeholder="请输入内容" class="layui-textarea"></textarea>
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">预置选择框</label>
            <div class="layui-input-block">
                <select name="city" lay-verify="required">
                    <option value=""></option>
                    <option value="0">北京</option>
                    <option value="1">上海</option>
                    <option value="2">广州</option>
                    <option value="3">深圳</option>
                    <option value="4">杭州</option>
                </select>
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">预置复选框</label>
            <div class="layui-input-block">
                <input type="checkbox" name="like[write]" title="写作">
                <input type="checkbox" name="like[read]" title="阅读" checked>
                <input type="checkbox" name="like[dai]" title="发呆">
            </div>
        </div>

        <div class="layui-form-item">
            <label class="layui-form-label">预置单选框</label>
            <div class="layui-input-block">
                <input type="radio" name="sex" value="男" title="男">
                <input type="radio" name="sex" value="女" title="女" checked>
            </div>
        </div>

        <div class="layui-form-item">
            <div class="layui-input-block">
                <button type="button" class="layui-btn" lay-submit lay-filter="submit">提交</button>
                <button type="reset" class="layui-btn layui-btn-primary">重置</button>
            </div>
        </div>

    </form>
</div>

<script src="../requireCommon/layui/layui.js"></script>
<script>
    layui.use('element', function(){
        var element = layui.element();
    });

    layui.use('form', function(){
        var form = layui.form();
        //监听提交
        form.on('submit(submit)', function(data){
            layer.msg(JSON.stringify(data.field));
            return false;
        });
    });

    // layer的图片上传 ，固定class为layui-upload-file
    layui.use('upload', function(){
        layui.upload({
            url: 'controller/base.php?act=uploadFile2'
            ,ext: 'jpg|png|gif'
            ,elem: '#exampleInputFile' //指定原始元素，默认直接查找class="layui-upload-file"
            ,method: 'post' //上传接口的http类型
            ,before: function(input){
                //返回的参数item，即为当前的input DOM对象
                console.log('文件上传中');
            }
            ,success: function(res){
                $("#ceshi_file").val(res.data);
            }
        });
    });

    $(document).on('click','.submit',function(){
        var form1 = $("#form1");
        $.ajax({
            type: "POST",
            url: "controller/control.php?act=addSmsConfig",
            dataType: 'json',
            data:form1.serialize(),
            success:function(data,status){
                console.log(data.info);
                $("div").tooltip({
                    method:'confirm',
                    title:'提示',
                    footer:'<button type="button" class="btn btn-default" onclick="javascript:location.reload()">关闭</button>',
                    content:data.info
                });
            },
            error:function(xhr, ajaxOptions, thrownError){
                console.log(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        })
    });

    //ajax上传图片 ceshi_file为上传文件后加入的表单name名称,并且要加载js文件
//    $(document).on('change','#exampleInputFile',function(){
//        ajaxFileUploadview('exampleInputFile','ceshi_file',"controller/base.php?act=uploadPhoto","/e/extend/alidayu/theme/pic/");
//    });

    function ajaxFileUploadview(idname,ziduan,url,newFileUrl){
        $.ajaxFileUpload({
            url:url,
            secureuri:false,
            fileElementId:idname,
            dataType:'json',
            data:{
                idname:idname,
                newFileUrl:newFileUrl
            },
            success:function(data,status){
                console.log(data);
                switch(data.ret){
                    case 200:
                        $("div").tooltip({
                            method:'confirm',
                            title:'提示',
                            footer:'<button type="button" class="btn btn-default" data-dismiss="modal">关闭</button>',
                            content:'上传成功！'
                        });
                        $("#"+ziduan).val(data.data);
                        $("#"+idname).parent().append('<img src="'+data.data+'" style="max-width=\'500px\'">');
                        break;
                    case 400:
                        $("div").tooltip({
                            method:'confirm',
                            title:'提示',
                            footer:'<button type="button" class="btn btn-default" data-dismiss="modal">关闭</button>',
                            content:data.info
                        });
                        break;
                }
            },
            error:function(data,status,e){
                console.log(e);
            }
        })
        return false;
    }
</script>

</body>
</html>
<?
db_close();
$empire = null;
?>  